#!/usr/bin/env python
# nuetzliche  imports
from numpy import *
from scipy.constants import c
from numpy.linalg import lstsq, norm
from matplotlib.pyplot import *


def F(x, X):
    """
    Residuenvektor

    Keyword Arguments:
    x -- Koordinaten des Blitzevents

    X enthaelt *zeilenweise* die Ankunftszeiten und die
    Koordinaten der Messtationen:

    X -- [[t_0, x_0, y_0],
          [t_1, x_1, y_1],
          ...,
          [t_N, x_N, y_N]]
    """
    # Ankunftszeiten
    T = X[:,0]

    # Positionen
    X = X[:,1:]

    # Anzahl Messwerte
    n = X.shape[0]

    # Dimension
    dim = X.shape[1]

    # Anzahl Paare
    rows = (n**2 -n)/2

    # Alloziere Speicher
    X1 = zeros((rows, dim))
    X2 = zeros_like(X1)
    T1 = zeros(rows)
    T2 = zeros_like(T1)


    # Iteriere ueber alle Paare
    offset = 0
    for i in xrange(n):
        for j in xrange(i+1, n):
            X1[offset, :] = X[i,:]
            X2[offset, :] = X[j,:]
            T1[offset] = T[i]
            T2[offset] = T[j]
            offset += 1


    #############################################
    #                                           #
    # TODO: erstelle hier den Residuenvektor Fr #
    #                                           #
    #############################################
    return Fr



#####################################################
#                                                   #
# TODO: Implementieren Sie eine Methode zur Loesung #
#       des nichtlinearen Ausgleichsproblems        #
#                                                   #
#####################################################




# Koordinaten der Messstationen
pos = array([[646923.3, 249090.5],     # Aarau
             [611364.9, 267008.3],     # Basel
             [601383.3, 199655.6],     # Bern
             [585733.3, 220755.6],     # Biel
             [759034.3, 191401.6],     # Chur
             [499938.8, 117165.5],     # Genf
             [533604.7, 153962.7],     # Lausanne
             [716284.3, 96401.6,],     # Lugano
             [665494.9, 210848.3],     # Luzern
             [689817.7, 284063.0],     # Schaffhausen
             [745813.2, 254140.5],     # St. Gallen
             [613773.3, 178140.5],     # Thun
             [682144.9, 247748.3]])    # Zurich

# Ankunftszeiten der Messungen fuer 3 Blitzeinschlaege
# (eine Liste mit 3 x n-Messungen)
arrival_times = [array([0.00027874,  0.00037867,  0.00023148,  0.00031638,  0.0003316 ,
                        0.00057982,  0.00044431,  0.00030359,  0.00014342,  0.00040244,
                        0.00039532,  0.00016997,  0.00027564]),
                 array([0.0002881 ,  0.00041792,  0.00041277,  0.00045913,  0.00014129,
                        0.00080656,  0.00066209,  0.00038481,  0.00019742,  0.00026669,
                        0.00016432,  0.0003875 ,  0.0001902 ]),
                 array([0.00043168,  0.00047805,  0.00024517,  0.00032749,  0.00055934,
                        0.00036154,  0.00026785,  0.00038328,  0.00034949,  0.00060042,
                        0.00063435,  0.00017912,  0.0004796 ])]

figure()
# Zeichne die Position der Messstationen
scatter(pos[:,0], pos[:,1], label='Messstationen')

# Iterationen ueber die Blitz-Ereignisse (3 Stueck)
for t in arrival_times:
    # Startwert
    x0 = array([600000, 100000])
    x = array([nan, nan])

    #Anzahl Iterationen
    it = 0

    ############################################################
    #                                                          #
    # TODO: Berechnen Sie hier die Einschlagsorte x der Blitze #
    #                                                          #
    ############################################################

    print('Anzahl Iterationen %d' % it)
    print('------------------')

    # Zeichne die errechnete Ereigniskoordinaten
    scatter(x[0], x[1], marker='o', c='r' ,label='Blitz')

grid(True)
savefig('blitzmap.pdf')
show()
