first_name = '' # TODO
last_name = '' # TODO
hand_in = False # TODO: set to True and run again before hand in. Hand in also the output* file

import sys
import os
if hand_in:
    filename = os.path.basename(__file__).split('.')[0]
    output = open(f'output_{filename}_{last_name}_{first_name}.txt', 'w')
    sys.stdout = output
    print(f"{filename}\n {last_name}, {first_name}")

#!/usr/bin/env python
from numpy import *
from numpy.linalg import qr, solve, norm
from matplotlib.pyplot import *

# The Potential
def parameterize_M(w):
    D, b, r = w
    M = lambda x: D * (exp(-2*b*(x-r)) - 2*exp(-b*(x-r)))
    return M

# Measured data
xs = array([4.5  ,   4.625,   4.75 ,   4.875,   5.   ,   5.125,   5.25 ,
            5.375,   5.5  ,   5.625,   5.75 ,   5.875,   6.   ,   6.125,
            6.25 ,   6.375,   6.5  ,   6.625,   6.75 ,   6.875,   7.   ,
            7.6  ,   8.2  ,   8.8  ,   9.4  ,  10.   ])

ms = array([0.00576927,  0.00253559,  0.00033111, -0.00134176, -0.00227398,
            -0.00332391, -0.00383527, -0.00409757, -0.00400621, -0.00418952,
            -0.00402253, -0.00399855, -0.00364467, -0.00357149, -0.00321943,
            -0.00299151, -0.00274346, -0.00246722, -0.0024028 , -0.00243918,
            -0.00199481, -0.00123247, -0.00081901, -0.00044782, -0.00032779,
            -0.00021248])

# Linear least squares
def lstsq(A, b):
    r"""
    A: Matrix
    b: Rechte Seite
    """
    ##############################################################
    #                                                            #
    # Implementieren Sie hier eine lineare least squares Loesung #
    # mithilfe der QR Zerlegung.                                 #
    #                                                            #
    ##############################################################
    pass


# Non-linear least squares
def F(w):
    r"""
    w: Vektor der Parameter [D, b, r]
    """
    M = parameterize_M(w)
    return (M(xs) - ms).reshape(-1,1)


def JF(w):
    r"""
    w: Vektor der Parameter [D, b, r]
    """
    D, b, r = w
    DF = lambda x: array([
            exp(-b*(x-r)) * (exp(-b*(x-r)) - 2.0),
            -2*D*(x-r) * exp(-b*(x-r)) * (exp(-b*(x-r))-1.0),
            2*b*D * exp(-b*(x-r)) * (exp(-b*(x-r))-1.0)
            ])
    return DF(xs).T


def gauss_newton(F, JF, wini, tol=1e-6):
    r"""
    F: die Funktion F
    JF: die Jacobi Matrix von F
    wini: Vektor der Parameter [D, b, r]
    tol: Toleranz der Loesung
    """
    w = wini
    #########################################################
    #                                                       #
    # Implementieren Sie hier den Gauss-Newton Algorithmus. #
    #                                                       #
    #########################################################
    return w


# Fit the Potential
wini = array([0.004, 1.0, 5.5])
print("Startwerte der Parameter [D, b, r]")
print(wini)

wsol = gauss_newton(F, JF, wini)

print("Fitwerte der Parameter [D, b, r]")
print(wsol)


# Plot the fit
Mini = parameterize_M(wini)
Msol = parameterize_M(wsol)

x = linspace(4.0, 10.0, 200)

figure(figsize=(12,8))
plot(xs, ms, "ro", label="Measurement")
plot(x, Mini(x), "r--", label="Initial guess $M(x)$")
plot(x, Msol(x), "r-", label="Fitted $M(x)$")
grid(True)
ylim(-0.005, 0.002)
xlabel(r"$x$")
ylabel(r"$M(x)$")
legend(loc="lower right")
savefig("morse_fit.png")


# Compute residual and plot it
residual = ones_like(xs)
###################################
#                                 #
# Berechnen Sie hier das Residuum #
#                                 #
###################################

figure()
semilogy(xs, residual, "o-")
grid(True)
xlabel(r"$x$")
ylabel(r"$|M(x_{i})-M_{i}|$")
savefig("morse_fit_res.png")
